import time

import es
import gamethread

info = es.AddonInfo()
info.basename = "spree"
info.name = "L4D Killing Spree counter"
info.author = "GODJonez"

players = {}
polling = False
cooldown = es.ServerVar('spree_cooldown', 5, 'Cooldown in seconds to count for killing spree')
ads = set()

def player_death(ev):
	global polling
	userid = int(ev['attacker'])
	if userid not in players:
		players[userid] = [1, time.time(), 0]
	else:
		kills = players[userid][0] + 1
		players[userid][0] = kills
		players[userid][1] = time.time()
	if not ads:
		gamethread.delayed(0, msg_em)
	ads.add(userid)
	if not polling:
		gamethread.delayed(float(cooldown), poll)
		polling = True

def getplayername(userid):
	if userid:
		return es.getplayername(userid)
	else:
		return "AI Director"

def msg_em():
	for userid in ads:
		kills, kt, last = players[userid]
		if kills > 1:
			delta = kills-last
			es.tell(userid, 'Killing spree: %d (%+d)'%(kills, delta))
			if delta > 5:
				es.msg('\x04%s\x03 hit a jackpot of %d!'%(getplayername(userid),delta))
		players[userid][2] = kills
	ads.clear()

def poll():
	global polling
	now = time.time()
	cd = float(cooldown)
	removes = set()
	mintime = now
	for userid, data in players.iteritems():
		dt = data[1]
		if now-dt>cd:
			kills = data[0]
			if kills > 1:
				es.msg('\x04%s\x03 got %d kills on their killing spree.'%(getplayername(userid),kills))
			removes.add(userid)
		elif dt < mintime:
			mintime = dt
	for userid in removes:
		del players[userid]
	if not players:
		polling = False
	else:
		gamethread.delayed(cd-now+mintime, poll)
